JavaFileObject.Kind (Java SE 25 & JDK 25)
Description: declaration: module: java.compiler, package: javax.tools, interface: JavaFileObject, enum: Kind
Keywords: javax.tools.JavaFileObject.Kind class

# Enum Class JavaFileObject.Kind

java.lang.Object
java.lang.Enum<JavaFileObject.Kind>
javax.tools.JavaFileObject.Kind

All Implemented Interfaces:
  `Serializable, Comparable<JavaFileObject.Kind>, Constable`

Enclosing interface:
  `JavaFileObject`

public static enum JavaFileObject.Kind extends Enum<JavaFileObject.Kind>
Kinds of JavaFileObjects.

Since:
  1.6

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CLASS`
  Class files for the Java Virtual Machine.
  `HTML`
  HTML files.
  `OTHER`
  Any other kind.
  `SOURCE`
  Source files written in the Java programming language.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `final String`
  `extension`
  The extension which (by convention) is normally used for this kind of file object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static JavaFileObject.Kind`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static JavaFileObject.Kind[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SOURCE

    public static final JavaFileObject.Kind SOURCE
    Source files written in the Java programming language. For example, regular files ending with `.java`.

  - ### CLASS

    public static final JavaFileObject.Kind CLASS
    Class files for the Java Virtual Machine. For example, regular files ending with `.class`.

  - ### HTML

    public static final JavaFileObject.Kind HTML
    HTML files. For example, regular files ending with `.html`.

  - ### OTHER

    public static final JavaFileObject.Kind OTHER
    Any other kind.

- ## Field Details

  - ### extension

    public final String extension
    The extension which (by convention) is normally used for this kind of file object. If no convention exists, the empty string (`""`) is used.

- ## Method Details

  - ### values

    public static JavaFileObject.Kind[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static JavaFileObject.Kind valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null